#include "Arduino.h"
#include "globals.h"
#ifndef TDC_CF
#define TDC_CF
void computeFeatures(float** buffer,float *mean, float* stddev, float* avgDif,uint32_t column,uint32_t windowSize){
  *mean=0;
  *avgDif=0;
  *stddev=0;
  for(uint32_t j=0;j<windowSize;j++){
    *mean+=buffer[j][column];
    if(j!=0)*avgDif+=buffer[j][column]-buffer[j-1][column];
  }
  *mean/=windowSize;
  *avgDif/=((windowSize)-1);

  for(uint32_t j=0;j<windowSize;j++){
    *stddev+=(*mean-buffer[j][column])*(*mean-buffer[j][column]);
  }
  *stddev/=((windowSize)-1);
  *stddev=sqrt(*stddev);
}


void allocBuffer(Treetype*** buf,uint32_t rows,uint32_t cols){
    *buf = new Treetype*[rows];
    uint32_t i;
    uint32_t j;
    if(*buf!=NULL){
        for(i=0;i<rows;i++){
            (*buf)[i] = new Treetype[cols];
            for(j=0;j<cols;j++){
                (*buf)[i][j]=0;
            }
        }
    // return buf;
    }else{
        *buf=NULL;
    }
    // return NULL;
}

void deallocBuffer(Treetype*** buf,uint32_t rows){
  uint32_t i;
  for(i=0;i<rows;i++){
      delete (*buf)[i];
  }
  delete *buf;
}
#endif
