#include <mbed.h>
#include "../lib/TinyDecisionTreeClassifier/src/TinyDecisionTreeClassifier.h"

#define NUMBER_OF_FEATURES  5
#define NUMBER_OF_SAMPLES   7
#define MAX_TREE_DEPTH      3
typedef float Treetype;
Treetype X_const[NUMBER_OF_SAMPLES][NUMBER_OF_FEATURES] =
{ {1,2,3,1,1},
  {1,2,1,1,1},
  {1,1,2,3,1},
  {1,2,3,1,2},
  {3,2,1,1,1},
  {1,2,3,1,2},
  {3,2,3,1,2},
  };

Treetype Y_const[NUMBER_OF_SAMPLES][1] = {
  {1},
  {0},
  {1},
  {0},
  {1},
  {1},
  {0},
  };

Treetype **X;
Treetype **Y;

int random(int min, int max) {
    return min + rand() % (max - min + 1);
}

void fillBuffersWithRandom(void){
  for(uint32_t i=0;i<NUMBER_OF_SAMPLES;i++){
    for(uint32_t j=0;j<NUMBER_OF_FEATURES;j++){
        X_const[i][j]=(Treetype)random(-128,127);
      }
      Y_const[i][0] = (Treetype)random(0,2);
  }
}

void saveLoadTest(void){
    for(uint32_t k=0;k<10;k++){
      printf("Start\n\r");
      fillBuffersWithRandom();
      uint32_t outputdatasize = 100;
      char* outputdata = (char*) malloc(outputdatasize);
      TinyDecisionTreeClassifier<Treetype> clf1(MAX_TREE_DEPTH,2);
      clf1.fit(X,Y,NUMBER_OF_SAMPLES,NUMBER_OF_FEATURES);
      clf1.plot();
      while(clf1.prune(X,Y,NUMBER_OF_SAMPLES));
      clf1.plot();
      clf1.save(&outputdata,&outputdatasize);
      printf("Tree saved, load start\n\r");

      TinyDecisionTreeClassifier<Treetype> clf2(MAX_TREE_DEPTH,2);
      clf2.load(outputdata);
      clf2.plot();
      free(outputdata);
      printf("Finished\n\r");
    }
   
}


int main () {
  printf("Begin\n\r");
  X = new Treetype *[NUMBER_OF_SAMPLES];
  Y = new Treetype *[NUMBER_OF_SAMPLES];
  for(uint32_t i=0;i<NUMBER_OF_SAMPLES;i++){
      X[i] = X_const[i];
      Y[i] = Y_const[i];
  }
  saveLoadTest();
  // clf.plot();
  while(1){
    ThisThread::sleep_for(chrono::milliseconds(100)); 
  }
  return 0;
}
