#ifndef TDC_PROCESSING_H
#define TDC_PROCESSING_H

#include <TinyDecisionTreeClassifier.h>
#include <stdint.h>
#include <stddef.h>

template< typename T>
void shuffleData(T** X, T** y, uint32_t rows, uint32_t cols){
    uint32_t i;
    uint32_t j;
    for (i=0;i<rows;i++){
            uint32_t swapwith = random(0, rows);
            for(j=0;j<cols;j++){
                T temp = X[i][j];
                X[i][j] = X[swapwith][j];
                X[swapwith][j] = temp;
            }
            T temp = y[i][0];
            y[i][0] = y[swapwith][0];
            y[swapwith][0] = temp;
        }
}

template< typename T>
void sampleBagging(typename TinyDecisionTreeClassifier<T>::RowsSubIndexes* rsi, uint32_t totalRows, uint32_t neededRows){
    uint32_t i;
    uint32_t j;
    uint32_t* indicies = new uint32_t[totalRows];
    if(indicies!=NULL){
        for(i=0;i<totalRows;i++){
            indicies[i]=i;
        }
        for (i=0;i<totalRows;i++){
            uint32_t swapwith = random(0, totalRows);

            uint32_t temp = indicies[i];

            indicies[i] = indicies[swapwith];
            indicies[swapwith] = temp;
        }
    
    rsi->indexes = (uint32_t*)realloc(rsi->indexes,neededRows*(sizeof(uint32_t)));
    rsi->size = neededRows;
    for(i=0;i<neededRows;i++){
        rsi->indexes[i]=indicies[i];
    }
    delete indicies;
    }
}

#endif